import argparse
import importlib
import json
#from pythontest.db.SimpleConnection import SimpleConnection


allmodules = [ 'AlwaysIssue', 'EvenCheck' ]

def run():
	config = getConfig()

	impl = getattr(importlib.import_module('pythontest.db.' + config['db']['impl']), config['db']['impl'])
	db = impl(config['db'])

	services = [ row['id'] for row in db.query('service:1,2') ]

	modules = [ importlib.import_module('pythontest.modules.' + module) for module in getModules() ]

	results = [ (module.__name__, issues) for module in modules for issues in module.checkServices(db, services) ]

	print(results)


def getModules():
	parser = argparse.ArgumentParser()
	parser.add_argument('-m', '--module')
	args = parser.parse_args()

	if args.module == None:
		modules = allmodules
	else:
		modules = [ args.module ]

	return modules


def getConfig():
	with open('config.json', 'r') as f:
		config = json.load(f)
	return config


if __name__ == '__main__':
	run()
